#include <SPI.h>
#include <SD.h>

#include <LiquidCrystal_I2C.h>

#include <SoftwareSerial.h>

#include <Servo.h>

//#define SCREEN_WIDTH 128
//#define SCREEN_HEIGHT 64

//#define OLED_RESET     -1
//Adafruit_SSD1306 //display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);

SoftwareSerial BL(30, 31); // RX, TX

//#define MaxFiles 5

File myFile;

Servo ServoC;
Servo ServoD;

#define okButton  11
#define upButton  32
#define downButton  33
//#define backButton  A3*/
#define trigPin 12
#define echoPin 13

#define touch1  14
#define touch2  15

#define Motor1Pin1  2
#define Motor1Pin2  5
#define ENablePin1  9

#define Motor2Pin1  6
#define Motor2Pin2  8
#define ENablePin2  3

#define LedPin 22

#define MAX_PROGRAMS 3


int lcdColumns = 16;
int lcdRows = 2;
/*#define S0 13
  #define S1 7
  #define S2 4
  #define S3 5
  #define sensorOut 6*/

int frequency = 0;
//int color = 0;

char* result[2];

//int lcdColumns = 16;
//int lcdRows = 2;

int motor1Speed = 0;        // Motor speed 0..255
int motor1Direction = 1;
int motor2Speed = 0;        // Motor speed 0..255
int motor2Direction = 1;

int FileNumber = 0;

int ServoCdir = 90;
int ServoDdir = 90;

int statusLCD;

unsigned long sleepLCD;

int var1 = 0;
int var2 = 0;
bool OkButvalue = 0;
bool UpButvalue = 0;
bool DownButvalue = 0;
//bool BackButvalue = 0;

bool firstTime = true;

//int chronometer = 0;

//int fileSize;

int pinCS = 53;
//char* tmp;
char* sensor;
char* SensorValue;
//char *tmp2;
//int fileSize;
char fileName[7] = "1.PRG";
char* programs[MAX_PROGRAMS];

String readString;


//String param;
//String command;

//String files[MaxFiles];

//int fileCount = 0;

bool runningProg = false;

#define USE_SD_CARD
#define FILE_FORMAT_VERSION 1

LiquidCrystal_I2C lcd(0x27, lcdColumns, lcdRows);

void execute(String command) {

  if (runningProg == true) {

    char *cmd;
    char *param;
    boolean hasParams = false;

    Serial.println(F("Checking command:"));
    Serial.println(command);

    int x = splitText(command.c_str(), ":", result);
    cmd = result[0];
    if (x > 0) {
      param = result[1];
    }
    Serial.println(F("command:"));
    Serial.println(cmd);


    Serial.println(F("param:"));
    Serial.println(param);
    /*
      for (int i = startIdx; i < endIdx; i++) {
      if (programs[FileNumber][i] == ":") {
        cmd = malloc(i - startIdx + 1);
        param = malloc(endIdx - i + 1);
        memcpy(programs[FileNumber] + startIdx, cmd, i - startIdx);
        memcpy(programs[FileNumber] + startIdx + i, param, endIdx - i);
        hasParams = true;
        break;
      }
      }

      if (!hasParams) {
      cmd = malloc(endIdx - startIdx + 1);
      memcpy(programs[FileNumber] + startIdx, cmd, endIdx - startIdx);
      }*/

    if (cmd[0] == 'C') {
      ServoC.write(atoi(param));
      Serial.println(F("ServoC:"));
      Serial.print(param);
    }
    else if (cmd[0] == 'D') {
      ServoD.write(atoi(param));
      Serial.println(F("ServoD:"));
      Serial.print(param);
    }
    else if (cmd[0] == 'W') {
      Serial.println(F("Waiting "));
      Serial.print(param);
      Serial.print(F("ms"));
      delay(param);
    }
    else if (cmd[0] == 'X') {
      myFile.close();
      runningProg = false;
      motor1Speed = 0;
      motor2Speed = 0;
      applyMotorPar();
      Serial.println(F("ProgramStop"));
      Print(F("Select program"), fileName);
    }
    else if (strcmp(cmd, "BLs") == 0) {
      BL.write(param);
      Serial.println(F("Sending  "));
      Serial.print(param);
      Serial.print(F("via BL"));
    }
    //str = "";
    //runningProg = false;
    //break;*/

    else if (cmd[0] == 'P') {
      //display.print(param);
      Serial.println(F("Printing:"));
      Serial.print(param);
      Print(param, "");
    }
    else if (cmd[0] == 'A') { // get first character

      if (param[0] == 'f') {
        motor1Direction = 1;
        motor1Speed = atoi(param + 1);
      }

      /*if (param[0] == 'a') {

        motor1Direction = 1;
        motor1Speed = atoi(param + 1);

        }*/

      else if (param[0] == 'b') {

        motor1Direction = 0;
        motor1Speed = atoi(param + 1);
      }

      applyMotorPar();

    } else  if (cmd[0] == 'B') {

      if (param[0] == 'f') {

        motor2Direction = 1;
        motor2Speed = atoi(param + 1);

      }   else if (param[0] == 'b') {

        motor2Direction = 0;
        motor2Speed = atoi (param + 1);

      }

      applyMotorPar();

      /*} else if (strcmp(cmd, "var1") == 0) {

        if (param[0] == '+') {

          var1 = var1 + atoi (param + 1);
        }
        if (param[0] == '-') {

          var1 = var1 - atoi (param + 1);
        }
        if (param[0] == '*') {

          var1 = var1 * atoi (param + 1);
        }
        if (param[0] == '/') {

          var1 = var1 / atoi (param + 1);
        }
        Serial.println(var1);

        } else if (strcmp(cmd, "var2") == 0) {

        if (param[0] == '+') {

          var2 = var2 + atoi (param + 1);
        }
        if (param[0] == '-') {

          var2 = var2 - atoi (param + 1);
        }
        if (param[0] == '*') {

          var2 = var2 * atoi (param + 1);
        }
        if (param[0] == '/') {

          var2 = var2 / atoi (param + 1);
        }

        Serial.println(var2);*/

    } else if (strcmp(cmd, "L") == 0) {

      Serial.print(F("Changing Led statement"));
      Serial.print(param[0]);

      if (strcmp(param, "0") == 0) {
        digitalWrite(LedPin, LOW);
        Serial.println(F("\nSetting Led to LOW"));
      }
      else if (strcmp(param, "1") == 0) {
        digitalWrite(LedPin, HIGH);
        Serial.println(F("\nSetting Led to HIGH"));
      }

    }

    /*if (strcmp(cmd, "if") == 0) {
      int x = splitText(param, "=", result);
      if (x > 0) {
        sensor  = result[0];
        SensorValue = result[1];

        if (sensor = "USonic") {

          if (!getDistance == SensorValue) {

            }
          }
      }

      }*/
    else {
      BL.write("E2");//invalid command
      Serial.println("E2");
    }

    /*
      free(cmd);
      if (hasParams) {
      free(param);
      }*/
  } else {
    return;
  }
}

void findCmd(char* text) {

  if (runningProg) {

    Serial.println(F("finding command"));

    String lala = text;
    Serial.println(lala);
    String command;

    int idx = lala.indexOf(';');
    Serial.println(idx);

    while (idx != -1) {
      command = lala.substring(0, idx);
      Serial.print(F("Sending for check: "));
      Serial.println(command);
      lala.remove(0, idx + 1);
      execute(command);

      idx = lala.indexOf(';');
    }
  }
}

void getFileList(File dir, String fileToRead) {

  Serial.println(F("getFileList"));

  String line;
  bool header_ok;
  bool version_ok;
  bool startReadingCommands;
  int fileIdx = 0;

  while (true)
  {
    File entry =  dir.openNextFile();
    if (! entry)
    {
      Serial.println(F("No more files"));
      break;
    }
    Serial.print(F("Found file:")); Serial.println(entry.name());

    String test = entry.name();

    if (!test.equalsIgnoreCase(fileToRead)) {
      Serial.println(F("Not this"));
      entry.close();
      continue;
    }

    if (fileIdx == MAX_PROGRAMS) {
      Serial.println(F("Cannot add more files. Array is full"));
      entry.close();
      continue;
    }
    /*
      Serial.println(test);
      //check if file is PROGRAM
      if (!test.endsWith("PRG")) {
      //if (strncmp( (char *)entry.name()+8, "PRG", 3) != 0) {
      Serial.println(F("Ignoring file cause extension"));
      continue;
      }

      if (test.equals("1.PRG")) {
      continue;
      }
    */
    Serial.print(F("Try to read file:"));
    Serial.println(entry.name());
    myFile = SD.open(entry.name(), FILE_READ);

    header_ok = false;
    version_ok = false;
    startReadingCommands = false;
    programs[fileIdx] = NULL;


    while (myFile.available()) {

      line = myFile.readStringUntil('\n');
      line.trim();
      if (line.startsWith("#")) {
        Serial.println(F("Inline comment:")); Serial.print(line);
      } else {
        if (header_ok && version_ok && line.equals("PROGRAM_END")) {
          Serial.println(F("\nstop reading commands"));
          startReadingCommands = false;
          Serial.println(F("Total program:"));
          Serial.println(programs[fileIdx]);
          fileIdx++;
        }
        if (header_ok && version_ok && startReadingCommands) {
          int len = line.length();
          if (len > 0) {
            Serial.println(F("adding program:"));
            Serial.println(line);
            if (programs[fileIdx] == NULL) {
              programs[fileIdx] = malloc(len + 1);
              strcpy(programs[fileIdx], line.c_str());
            } else {
              int old_size = strlen(programs[fileIdx]);
              programs[fileIdx] = realloc(programs[fileIdx], old_size + len + 1);
              strcpy(programs[fileIdx] + old_size, line.c_str());
            }
          } else {
            Serial.println(F("Ignoring empty line"));
          }
        }
        if (line.equals("PDRS_ROBOT")) {
          header_ok = true;
          Serial.println(F("Header is ok"));
        }
        if (header_ok && line.startsWith("VERSION:")) {
          Serial.println(F("Reading version"));
          line.replace("VERSION:", "");
          if (line.toInt() <= FILE_FORMAT_VERSION) {
            Serial.println(F("version is ok"));
            version_ok = true;
          } else {
            Serial.println(F("found:"));
            Serial.print(line);
          }
        }
        if (header_ok && version_ok && line.equals("PROGRAM_START")) {
          Serial.println(F("start Reading Commands"));
          startReadingCommands = true;
        }

      }
    }
    myFile.close();
    entry.close();

  }

  Serial.println(F("Operation completed"));
}

void readCardFiles() {

  if (runningProg == true) {
    if (firstTime == false) {

#ifdef USE_SD_CARD
      File rootDirectory = SD.open("/");
      Serial.println(F("readCardFiles"));
      getFileList(rootDirectory, fileName);

#else
      //tmp = malloc(255);
      for (int i = 0; i < MAX_PROGRAMS; i++) {
        programs[i] = malloc(50);
      }

      strcpy(programs[0], "C:180;W:500;C:0;X;");
      strcpy(programs[1], "A:f255;W:1000;A:b150;W:1000;A:f200;X;");
      strcpy(programs[2], "D:180;W:1000;D:90;W:1000;D:0;W:1000;D:180;X;");
#endif
    }
  }
}

void Print(String line1, String line2) {

  statusLCD = HIGH;
  lcd.setBacklight(HIGH);
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print(line1);
  lcd.setCursor(0, 1);
  lcd.print(line2);
  sleepLCD = millis();

}

void setup() {

  //sprintf(fileName, "%d.txt", FileNumber);
  pinMode(okButton, INPUT);
  pinMode(upButton, INPUT);
  pinMode(downButton, INPUT);
  //pinMode(backButton, INPUT);
  pinMode(touch1, INPUT);
  pinMode(touch2, INPUT);

  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);

  pinMode(Motor1Pin1, OUTPUT);      // 1A
  pinMode(Motor1Pin2, OUTPUT);      // 2A
  pinMode(ENablePin1, OUTPUT);      // EN1
  pinMode(Motor2Pin1, OUTPUT);      // 3A
  pinMode(Motor2Pin1, OUTPUT);      // 4A
  pinMode(ENablePin2, OUTPUT);      // EN2

  digitalWrite(ENablePin1, LOW);
  digitalWrite(ENablePin2, LOW);

  pinMode(LedPin, OUTPUT);

  pinMode(pinCS, OUTPUT);


  Serial.begin(9600);
  //findCmd("C:180;W:500;C:0;X;");

  ServoC.attach(4);
  ServoD.attach(10);

  lcd.init();
  lcd.backlight();
  lcd.setCursor(0, 0);
  /*display.cleardisplay();
    display.setTextSize(1);
    display.setTextColor(WHITE);
    display.setCursor(0, 0);
    display.display();*/
  BL.begin(9600);

  statusLCD = LOW;

  /*while (!BL) {
    ; // wait for serial port to connect. Needed for native USB port only
    }

    display.print("Initializing SD card...");
    display.display();*/
  Serial.println(F("Starting..."));
  Print(F("Lego Hybrid"), F("Starting"));
  delay(2000);
  Serial.println(F("Beginning SD card..."));

  if (!SD.begin()) {
    //display.clearDisplay();
    Serial.print(F("Error reading SD card"));
    Print(F("Error reading"), F("SD card"));
    BL.write("E1");
    //display.display();
    while (1);
  }
  //display.clearDisplay();
  Serial.println(F("SD begin done"));



  //ServoCdir = 0;
  //ServoC.write(ServoCdir);

  //ServoDdir = 0;
  //ServoD.write(ServoDdir);
  /*display.display();
    open the file for reading:

    //File root = SD.open("/");
    //printDirectory(root);

    if (myFile) {
    display.clearDisplay();
    display.print("Opening file");
    display.display();
    // read from the file until there's nothing else in it:

    // close the file:
    //myFile.close();
    } else {
    // if the file didn't open, print an error message:
    display.clearDisplay();
    display.print("Error opening file");
    display.display();
    }
    sprintf(tmp, "%d.txt", FileNumber);
    fileName = tmp;
    //readCardFiles();//
    //findCmd(programs[0]);//*/
  Print(F("Select program"), fileName);
  delay(1000);
}

int splitText(char* text, char* delimiter, char *myArray[]) {

  char * token = strtok(text, delimiter);
  int i = 0;
  while (token != NULL ) {
    myArray[i++] = token;
    token = strtok(NULL, delimiter);
  }
  return i - 1;
}

void applyMotorPar() {

  if (motor1Direction == 0) {
    digitalWrite(Motor1Pin1, HIGH);
    digitalWrite(Motor1Pin2, LOW);

  } else {
    digitalWrite(Motor1Pin1, LOW);
    digitalWrite(Motor1Pin2, HIGH);
  }
  analogWrite(ENablePin1, motor1Speed);
  Serial.println(F("Motor 1:"));
  Serial.print(motor1Direction);
  Serial.print(F("   Speed:"));
  Serial.print(motor1Speed);
  Serial.print("\n");

  if (motor2Direction == 0) {

    digitalWrite(Motor2Pin1, HIGH);
    digitalWrite(Motor2Pin2, LOW);

  } else {
    digitalWrite(Motor2Pin1, LOW);
    digitalWrite(Motor2Pin2, HIGH);
  }

  analogWrite(ENablePin2, motor2Speed);
  Serial.println(F("Motor 2:"));
  Serial.print(motor2Direction);
  Serial.print(F("   Speed:"));
  Serial.print(motor2Speed);
  Serial.print("\n");
}

void loop() {


  delay(200);
  OkButvalue   = digitalRead(okButton);
  UpButvalue   = digitalRead(upButton);
  DownButvalue = digitalRead(downButton);
  //BackButvalue = digitalRead(backButton);


  Serial.println(fileName);

  if ( (statusLCD == HIGH) && (millis() - sleepLCD >= 4000) ) { //4 sec
    statusLCD = LOW;
    lcd.setBacklight(LOW);      // Backlight off
  }

  if (!runningProg) {

    if (DownButvalue == 1) {
      delay(200);
      Serial.println(F("DB pressed"));
      if (FileNumber > 1) {
        FileNumber--;
        sprintf(fileName, "%d.PRG", FileNumber);
        Serial.println(fileName);
        Print(F("Select program"), fileName);
      }
    }

    if (UpButvalue == 1) {
      delay(200);
      Serial.println(F("UB pressed"));
      if (FileNumber < MAX_PROGRAMS) {

        FileNumber++;
        sprintf(fileName, "%d.PRG", FileNumber);

        if (SD.exists(fileName)) {

          sprintf(fileName, "%d.PRG", FileNumber);
          Serial.println(fileName);
          Print(F("Select program"), fileName);

        } else {
          FileNumber--;
          sprintf(fileName, "%d.PRG", FileNumber);
        }
      }

    }

    if (!runningProg && OkButvalue == 1) {

      //fileSize = 100;
      //tmp2 = malloc(fileSize);
      //strcpy(tmp2, "C=90;W=500;C=0;W=500;C=180;X;");
      //if(SD.exists(fileName)){
      ////lcd.clear();
      ////lcd.setCursor(0, 0);
      //lcd.print(F("Running"));
      //lcd.setCursor(8, 0);
      //lcd.print(F("1.PRG"));
      Print(F("Running"), fileName);
      firstTime = false;
      runningProg = true;
      readCardFiles();//
      findCmd(programs[0]);//
      //myFile = SD.open(fileName);
      Serial.println(F("Running Program"));
      //Serial.println(fileName);


    } else {
      //display.clearDisplay();
      //Serial.println("File does not exist!");
    }
    /*if (myFile) {
      display.clearDisplay();
        display.print("Opening file");
        display.display();
        // read from the file until there's nothing else in it:
        str = "";
      }*/

    if (runningProg) {
      Serial.println("spliting a command");
      findCmd(programs[0]);

      /*int st = 0;
        int idx = 0;
        while (idx < strlen(programs[FileNumber])) {

          Serial.println(F("inside while"));

          if (programs[FileNumber][idx] == ';') {

            Serial.println(F("inside if"));
            //execute(st, idx);
            st = idx + 1;
          }
          idx++;
          Serial.println(idx);
        }*/
    }


    /*
      if (runningProg && digitalRead(okButton) == 1) {
      runningProg = false;
      }*/

    /*while (Serial.available()) {
      delay(10);

      char c = Serial.read();
      if (c == '.') {
        break;
      }
      readString += c;
      }
      BL.write(myFile.read());*/



    /*
      while (fileLines.length() > 0) {

      //Serial.println(fileLines);

      //remove "=" from command

      int idx = fileLines.indexOf("=", 0);
      command = fileLines.substring(0, idx);
      fileLines.remove(0, idx + 1);

      Serial.print(F("command="));
      Serial.println(command);

      idx = fileLines.indexOf(";", 0);
      parameters = fileLines.substring(0, idx);
      fileLines.remove(0, idx + 1);

      Serial.print(F("parameters="));
      Serial.println(parameters);




      (command, parameter);
        }
      }*/
    if (readString == "PM") {
      delay(1000);
      Print(F("Programming"), F("Mode"));
      SD.remove(fileName);
      SD.open(fileName, FILE_WRITE);
      myFile.print(readString);
    }

    runningProg = false;

  }
}



/*void printDirectory(File dir) {

  while (true)
  {
    File entry = dir.openNextFile();
    if (! entry)
    {
      //Serial.println(F("** Done **"));
      return;
    }

    files[fileCount] = entry.name();
    Serial.print(files[fileCount]);
    fileCount++;
    if (fileCount > MaxFiles) {
      //display.print("Array is full! Cannot add more files.");
      //display.//display();
      return;
    }

    if (entry.isDirectory())
    {
      //Serial.println(F("/"));
      printDirectory(entry);
    }
    entry.close();
  }
  }*/

/*String readLine (File f) {
  char c;
  String s1;
  s1 = "";

  while (f.available()) {
    //c = //myFile.read();
    if (c == "\n") {
      break;
    } else {
      s1 += c;
    }
  }
  return s1;
  }*/



/*void NoActionNotify() {

  if (chronometer < 300) {
    delay(10000);
    chronometer=+ 10;

  } else {
    chronometer = 0;
    BL.write("5minNoAction");
  }
  }

  long getDistance() {

  long duration, distance;
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  duration = pulseIn(echoPin, HIGH);
  distance = (duration / 2) / 29.1;
  return distance;
  }*/
